<template>
  <v-progress-linear
    rounded
    :value="(progress || 0) * 100"
    class="progress-no-smoothing"
    color="red lighten-3"
    :background-color="progress === null ? 'white' : 'red darken-3'"
  />
</template>
<script lang="ts">

import {
  Vue, Component, Prop, VModel, Watch, Emit,
} from 'vue-property-decorator';

@Component
export default class TapBar extends Vue {
  @VModel({ required: true })
  started!: boolean;

  @Prop({ default: 1 })
  duration!: number;

  progress: number | null = null;

  animationHandle: number | null = null;

  startTime: number | null = null;

  mounted() {
    this.onStartedChange();
  }

  @Watch('value')
  onStartedChange() {
    this.reset();
    if (this.started) {
      this.progress = 0;
      this.animationHandle = requestAnimationFrame(this.step);
    }
  }

  step(time: number) {
    if (this.startTime === null) this.startTime = time;

    const timeSinceStart = time - this.startTime;

    const scaledTime = timeSinceStart / 1000 / this.duration;

    if (scaledTime < 1) {
      this.progress = scaledTime;
      this.emitProgress(this.progress);
      requestAnimationFrame(this.step);
    } else {
      this.finished();
    }
  }

  reset() {
    if (this.animationHandle !== null) cancelAnimationFrame(this.animationHandle);
    this.progress = null;
    this.animationHandle = null;
    this.startTime = null;
  }

  @Emit('progress')
  emitProgress(t: number): number {
    return t;
  }

  @Emit()
  finished(): void {
    this.started = false;
    this.reset();
  }
}
</script>
<style lang="scss" scoped>
.progress-no-smoothing {
  transition: none;
}
</style>
